DROP TABLE IF EXISTS onboarding.marketing_wo_info_npath;
CREATE TABLE onboarding.marketing_wo_info_npath
    DISTRIBUTE BY HASH(cmusno) 
    COMPRESS AS (
    SELECT *
    FROM NPATH(
    ON (SELECT *
    FROM onboarding.event_list_18_0_to_90_removed where domain_type in ('MARKETING_OFFER','acq_chn') 
	--and upper(event_desc) not like'%INFO%'
	--and upper(event_desc) not like'LB%' and event_desc not like '%OthChannel%'
		)
    PARTITION BY cmusno
    ORDER BY row_number
    MODE('NONOVERLAPPING')
    SYMBOLS(
	domain_type ='acq_chn' AS a,
	event_desc like '%SMS_Camp%' AS b
			)       
    PATTERN('a.b+')   
	--PATTERN('a.b{1,7}')  
    RESULT(
		ACCUMULATE(event_desc OF ANY(a,b)) AS path,
		FIRST(cmusno OF a) AS cmusno,
		COUNT(cmusno OF ANY(a,b)) AS lenPath,
		FIRST(event_date OF a) AS start_date,
		LAST(event_date OF ANY(b)) AS end_date
		)
	)
    );
GRANT ALL ON onboarding.marketing_wo_info_npath TO db_analytics; 

/*SELECT DISTINCT domain_type, event_desc, event_id
    FROM onboarding.event_list_18_0_to_90_removed; */
	

	
-- Aggregate paths, calculate duration and path counts
DROP TABLE IF EXISTS onboarding.freq_marketing_wo_info_npath;
CREATE TABLE onboarding.freq_marketing_wo_info_npath
DISTRIBUTE BY HASH(path)
COMPRESS AS (
	select path, cast(avg( cast (end_date as date) - cast (start_date as date) ) as integer) duration, lenPath, count(*) cnt
	from onboarding.marketing_wo_info_npath
	group by 1, lenPath
);
grant all on onboarding.freq_marketing_wo_info_npath to db_analytics;



-- See the Unique Paths
select count (*) from onboarding.freq_marketing_wo_info_npath; -- 11863 Unique Paths

-- Single user paths
select count(*) from onboarding.freq_marketing_wo_info_npath where cnt = 1; --9023 individual paths

-- NoF paths which have at least 2 customers 
select count(*) from onboarding.freq_marketing_wo_info_npath where cnt >= 2; --2840

select count(*) from onboarding.freq_marketing_wo_info_npath where cnt >= 10; --448

select count(*) from onboarding.freq_marketing_wo_info_npath where cnt >= 20; --206

select count(*) from onboarding.freq_marketing_wo_info_npath where cnt >= 30; --138



-- Visualization Code for AppCenter

--INSERT INTO app_center_visualizations  (json) 
--SELECT json FROM Visualizer (
--ON (select * from onboarding.freq_marketing_wo_info_npath where cnt>=5   )  PARTITION BY 1 
--AsterFunction('npath') 
--Title('42-marketing_wo_info') 
--VizType('tree')
--);


--INSERT INTO app_center_visualizations  (json) 
--SELECT json FROM Visualizer (
--ON (select * from onboarding.freq_marketing_wo_info_npath where cnt>=5 and lenpath<=10  )  PARTITION BY 1 
--AsterFunction('npath') 
--Title('42-marketing_wo_info') 
--VizType('sankey')
--);