DROP TABLE IF EXISTS onboarding.debit_card_onbrd_mar_npath;
CREATE TABLE onboarding.debit_card_onbrd_mar_npath
    DISTRIBUTE BY HASH(cmusno) 
    COMPRESS AS (
    SELECT *
    FROM NPATH(
    ON (SELECT *
    FROM onboarding.event_list_18_0_to_90_removed
    WHERE domain_type IN ('acq_chn', 'DEBIT_CARD') or (event_desc like '%Onbrd%' and domain_type='MARKETING_OFFER')
		)
    PARTITION BY cmusno
    ORDER BY row_number
    MODE('NONOVERLAPPING')
    SYMBOLS(domain_type IN ('acq_chn') AS a,
	true as b
	--event_desc like '%Onbrd%' c,
	--domain_type = 'DEBIT_CARD' AS d,
			)
        
    PATTERN('a.b+')  -- Get all the debit card customer events
    RESULT(
		ACCUMULATE(event_desc OF ANY(a, b)) AS path,
		FIRST(cmusno OF a) AS cmusno,
		COUNT(cmusno OF ANY(a, b)) AS lenPath,
		FIRST(event_date OF a) AS start_date,
		LAST(event_date OF ANY(b)) AS end_date
		)
	)
    );
GRANT ALL ON onboarding.debit_card_onbrd_mar_npath TO db_analytics; 

/*SELECT DISTINCT domain_type, event_desc, event_id
    FROM onboarding.event_list_18_0_to_90_removed; */
	

	
-- Aggregate paths, calculate duration and path counts
DROP TABLE IF EXISTS onboarding.freq_debit_card_onbrd_mar_npath;
CREATE TABLE onboarding.freq_debit_card_onbrd_mar_npath
DISTRIBUTE BY HASH(path)
COMPRESS AS (
	select path, cast(avg( cast (end_date as date) - cast (start_date as date) ) as integer) duration, lenPath, count(*) cnt
	from onboarding.debit_card_onbrd_mar_npath
	group by 1, lenPath
);
grant all on onboarding.freq_debit_card_onbrd_mar_npath to db_analytics;





--NoF customers who have closing event without opening
select sum(cnt) from onboarding.freq_debit_card_onbrd_mar_npath  where path like '%DCClose%' and path not like '%DCOpen%' ; --2317
-- See the Unique Paths
select count (*) from onboarding.freq_debit_card_onbrd_mar_npath; -- 127 Unique Paths

-- Single user paths
select count(*) from onboarding.freq_debit_card_onbrd_mar_npath where cnt = 1; --38 individual paths

-- NoF paths which have at least 2 customers 
select count(*) from onboarding.freq_debit_card_onbrd_mar_npath where cnt >= 2; --89

--Customers who have only debit card close events
select count(*) from onboarding.debit_card_npath where path ='[0_SUBE, DCClose]' --800
select * from onboarding.freq_debit_card_onbrd_mar_npath  where path ='[0_SUBE, DCClose]';


-- Visualization Code for AppCenter

--INSERT INTO app_center_visualizations  (json) 
--SELECT json FROM Visualizer (
--    ON (select * from onboarding.freq_debit_card_onbrd_mar_npath where cnt>=2) PARTITION BY 1 
--AsterFunction('npath') 
--Title('45-debit_card_onbrd_mar_npath') 
--VizType('tree')
--);

