-- See all credit card related activity for the customers after getting first approval
DROP TABLE IF EXISTS onboarding.credit_card_txn_npath;
CREATE TABLE onboarding.credit_card_txn_npath
    DISTRIBUTE BY HASH(cmusno) 
    COMPRESS AS (
    SELECT *
    FROM NPATH(
    ON (SELECT *
    FROM onboarding.event_list_18_0_to_90_removed
    WHERE domain_type IN ('acq_chn', 'CREDIT_CARD', 'CreditCard')) 
    PARTITION BY cmusno
    ORDER BY row_number
    MODE('NONOVERLAPPING')
    SYMBOLS(domain_type IN ('acq_chn') AS a,
    true as b
    )       
    PATTERN('a.b+')  -- Get all the paths where there is one credit card application approval
    RESULT(ACCUMULATE(event_desc OF ANY(a, b)) AS path,
    FIRST(cmusno OF a) AS cmusno,
    COUNT(cmusno OF ANY(a, b)) AS lenPath,
    FIRST(event_date OF a) AS start_date,
    LAST(event_date OF ANY(a,b)) AS end_date)
    )
    );
GRANT ALL ON onboarding.credit_card_txn_npath TO db_analytics;

SELECT DISTINCT domain_type, event_desc, event_id
    FROM onboarding.event_list_18_0_to_90_removed;

--Accumulate paths
DROP TABLE IF EXISTS onboarding.freq_credit_card_txn_npath;
CREATE TABLE onboarding.freq_credit_card_txn_npath
    DISTRIBUTE BY HASH(path)
    COMPRESS AS (
    SELECT path, CAST(avg( CAST (end_date AS DATE) - CAST (start_date AS DATE) ) AS INTEGER) duration, lenPath, count(*) cnt
    FROM onboarding.credit_card_txn_npath
    WHERE lenPath >= 2
    GROUP BY 1, lenPath
    );
GRANT ALL ON onboarding.freq_credit_card_txn_npath TO db_analytics;


select count(*) from onboarding.freq_credit_card_txn_npath where cnt>=2

--INSERT INTO app_center_visualizations  (json) 
--SELECT json FROM Visualizer (
--    ON (select * from onboarding.freq_credit_card_txn_npath where cnt>=2 ) PARTITION BY 1 
--AsterFunction('npath') 
--Title('47-credit_card_txn_npath') 
--VizType('tree'));




--------------------------------------------------------------------------------------------------------------

-- See all credit card related activity for the customers after getting first approval
DROP TABLE IF EXISTS onboarding.credit_card_txn_npath;
CREATE TABLE onboarding.credit_card_txn_npath
    DISTRIBUTE BY HASH(cmusno) 
    COMPRESS AS (
    SELECT *
    FROM NPATH(
    ON (SELECT *
    FROM onboarding.event_list_18_0_to_90_removed
    WHERE domain_type IN ('acq_chn', 'CREDIT_CARD', 'CreditCard')) 
    PARTITION BY cmusno
    ORDER BY row_number
    MODE('NONOVERLAPPING')
    SYMBOLS(domain_type IN ('acq_chn') AS a,
    true as b
    )       
    PATTERN('a.b{1,4}')  -- Get all the paths where there is one credit card application approval
    RESULT(ACCUMULATE(event_desc OF ANY(a, b)) AS path,
    FIRST(cmusno OF a) AS cmusno,
    COUNT(cmusno OF ANY(a, b)) AS lenPath,
    FIRST(event_date OF a) AS start_date,
    LAST(event_date OF ANY(a,b)) AS end_date)
    )
    );
GRANT ALL ON onboarding.credit_card_txn_npath TO db_analytics;



--Accumulate paths
DROP TABLE IF EXISTS onboarding.freq_credit_card_txn_npath;
CREATE TABLE onboarding.freq_credit_card_txn_npath
    DISTRIBUTE BY HASH(path)
    COMPRESS AS (
    SELECT path, CAST(avg( CAST (end_date AS DATE) - CAST (start_date AS DATE) ) AS INTEGER) duration, lenPath, count(*) cnt
    FROM onboarding.credit_card_txn_npath
    WHERE lenPath >= 2
    GROUP BY 1, lenPath
    );
GRANT ALL ON onboarding.freq_credit_card_txn_npath TO db_analytics;



--INSERT INTO app_center_visualizations  (json) 
--SELECT json FROM Visualizer (
--    ON (select * from onboarding.freq_credit_card_txn_npath ) PARTITION BY 1 
--AsterFunction('npath') 
--Title('47-credit_card_txn_npath') 
--VizType('sankey'));