DROP TABLE IF EXISTS onboarding.app_loan_ccard_npath;
CREATE TABLE onboarding.app_loan_ccard_npath
DISTRIBUTE BY HASH(cmusno) 
COMPRESS AS (
		SELECT * 
		FROM npath(
		ON (select * from onboarding.event_list_18_0_to_90_removed
			where domain_type in ('acq_chn','APPLICATION','LOAN', 'CREDIT_CARD'))
		PARTITION BY cmusno
		ORDER BY row_number
		MODE('NONOVERLAPPING')
		SYMBOLS(domain_type in ('acq_chn') as a,
				true as b)
		PATTERN('a.b+')
		RESULT(ACCUMULATE(event_desc of any(a, b)) as path,
			   FIRST(cmusno of a) as cmusno,
			   COUNT(cmusno of any(a, b)) as lenPath,
			   FIRST(event_date of a) as start_date,
			   LAST(event_date of b) as end_date)
	)
);
grant all on onboarding.app_loan_ccard_npath to db_analytics;

DROP TABLE IF EXISTS onboarding.freq_app_loan_ccard_npath;
CREATE TABLE onboarding.freq_app_loan_ccard_npath
DISTRIBUTE BY HASH(path)
COMPRESS AS (
	select path, cast(avg( cast (end_date as date) - cast (start_date as date) ) as integer) duration, lenPath, count(*) cnt
	from onboarding.app_loan_ccard_npath
	where lenPath >= 2
	group by 1, lenPath
);
grant all on onboarding.freq_app_loan_ccard_npath to db_analytics;

--
SELECT count (*) FROM onboarding.freq_app_loan_ccard_npath where cnt >= 5;