DROP TABLE IF EXISTS onboarding.all_to_marketing_revoked_npath;
CREATE TABLE onboarding.all_to_marketing_revoked_npath
DISTRIBUTE BY HASH(cmusno) 
COMPRESS AS (
		SELECT * 
		FROM npath(
		ON (select cmusno,event_id, 
		case when event_desc in ('MarPermRevoked_Call', 'MarPermRevoked_Email', 'MarPermRevoked_SMS') 
				then 'Revoke' else event_desc end event_desc, 
		domain_type, acq_chn, chn_type, event_date, row_number 
from onboarding.event_list_18_0_to_90_removed
			)
		PARTITION BY cmusno
		ORDER BY row_number
		MODE('NONOVERLAPPING')
		SYMBOLS(domain_type in ('acq_chn') as a,
				--domain_type in ('MARKETING_OFFER') as b,
				event_desc ='Revoke' as c,
				event_desc <>'Revoke' as d)
		PATTERN('a.d*.c')  
		RESULT(ACCUMULATE(event_desc of any(a, c, d)) as path,
			   FIRST(cmusno of a) as cmusno,
			   COUNT(cmusno of any(a,c,d)) as lenPath,
			   FIRST(event_date of a) as start_date,
			   LAST(event_date of c) as end_date)
	)
);
grant all on onboarding.all_to_marketing_revoked_npath to db_analytics;

DROP TABLE IF EXISTS onboarding.freq_all_to_marketing_revoked_npath;
CREATE TABLE onboarding.freq_all_to_marketing_revoked_npath
DISTRIBUTE BY HASH(path)
COMPRESS AS (
	select path, cast(avg( cast (end_date as date) - cast (start_date as date) ) as integer) duration, lenPath, count(*) cnt
	from onboarding.all_to_marketing_revoked_npath
	where lenPath >= 2
	group by 1, lenPath
);
grant all on onboarding.freq_all_to_marketing_revoked_npath to db_analytics;


--INSERT INTO app_center_visualizations  (json) 
--SELECT json FROM Visualizer (
--    ON (select * from onboarding.freq_all_to_marketing_revoked_npath where cnt>=2) PARTITION BY 1 
--AsterFunction('npath') 
--Title('49-all_to_marketing_revoked') 
--VizType('tree'));