
DROP TABLE IF EXISTS onboarding.deposit_npath;
CREATE TABLE onboarding.deposit_npath
DISTRIBUTE BY HASH(cmusno) 
COMPRESS AS (
		SELECT * 
		FROM npath(
		ON (select * from onboarding.event_list_18_0_to_90_removed)
		PARTITION BY cmusno
		ORDER BY row_number
		MODE('NONOVERLAPPING')
		SYMBOLS(domain_type in ('acq_chn') as a,
				true as b,
				event_desc in 
('DepositOpening_O/N',
'DepositClosing_O/N',
'DepositClosing_TimeDeposit',
'DepositOpening_TimeDeposit') as c
				)
		PATTERN('a.c+.b*')
		RESULT(ACCUMULATE(event_desc of any(a, b,c)) as path,
			   FIRST(cmusno of a) as cmusno,
			   COUNT(cmusno of any(a, b,c)) as lenPath,
			   FIRST(event_date of a) as start_date,
			   LAST(event_date of b) as end_date)
	)
);
grant all on onboarding.deposit_npath to db_analytics;

DROP TABLE IF EXISTS onboarding.freq_deposit_npath;
CREATE TABLE onboarding.freq_deposit_npath
DISTRIBUTE BY HASH(path)
COMPRESS AS (
	select path, cast(avg( cast (end_date as date) - cast (start_date as date) ) as integer) duration, lenPath, count(*) cnt
	from onboarding.deposit_npath
	where lenPath >= 2
	group by 1, lenPath
);
grant all on onboarding.freq_deposit_npath to db_analytics;

--
SELECT count (*) FROM onboarding.freq_deposit_npath where cnt >= 5;




DROP TABLE IF EXISTS onboarding.deposit_npath;
CREATE TABLE onboarding.deposit_npath
DISTRIBUTE BY HASH(cmusno) 
COMPRESS AS (
		SELECT * 
		FROM npath(
		ON (select * from onboarding.event_list_18_0_to_90_removed)
		PARTITION BY cmusno
		ORDER BY row_number
		MODE('NONOVERLAPPING')
		SYMBOLS(domain_type in ('acq_chn') as a,
				event_desc not in 
('DepositOpening_O/N',
'DepositClosing_O/N',
'DepositClosing_TimeDeposit',
'DepositOpening_TimeDeposit') as b,
				event_desc in 
('DepositOpening_O/N',
'DepositClosing_O/N',
'DepositClosing_TimeDeposit',
'DepositOpening_TimeDeposit') as c
				)
		PATTERN('a.c+.b*')
		RESULT(ACCUMULATE(event_desc of any(a, b,c)) as path,
			   FIRST(cmusno of a) as cmusno,
			   COUNT(cmusno of any(a, b,c)) as lenPath,
			   FIRST(event_date of a) as start_date,
			   LAST(event_date of any(b,c)) as end_date)
	)
);
grant all on onboarding.deposit_npath to db_analytics;

DROP TABLE IF EXISTS onboarding.freq_deposit_npath;
CREATE TABLE onboarding.freq_deposit_npath
DISTRIBUTE BY HASH(path)
COMPRESS AS (
	select path, cast(avg( cast (end_date as date) - cast (start_date as date) ) as integer) duration, lenPath, count(*) cnt
	from onboarding.deposit_npath
	where lenPath >= 2
	group by 1, lenPath
);
grant all on onboarding.freq_deposit_npath to db_analytics;
