
DROP TABLE IF EXISTS onboarding.inbound_revoked_npath;
CREATE TABLE onboarding.inbound_revoked_npath
DISTRIBUTE BY HASH(cmusno) 
COMPRESS AS (
		SELECT * 
		FROM npath(
		ON (select cmusno,event_id, 
		case when event_desc in ('MarPermRevoked_Call', 'MarPermRevoked_Email', 'MarPermRevoked_SMS') 
				then 'Revoke' else event_desc end event_desc, 
		domain_type, acq_chn, chn_type, event_date, row_number  from onboarding.event_list_18_0_to_90_removed
			where   domain_type='acq_chn' 
				or (domain_type='CALL_CENTER' and event_desc like '%inboun%') 
				--or (domain_type='MARKETING_OFFER' and event_desc like '%Info%')
				or (domain_type='CUST_INFO' and event_desc like '%Revoked%'))
		PARTITION BY cmusno
		ORDER BY row_number
		MODE('NONOVERLAPPING')
		SYMBOLS(domain_type in ('acq_chn') as a,
				domain_type='CUST_INFO' as b,
				domain_type<>'CUST_INFO' as c)
		PATTERN('a.b.c{0,3}')  
		RESULT(ACCUMULATE(event_desc of any(a, b, c)) as path,
			   FIRST(cmusno of a) as cmusno,
			   COUNT(cmusno of any(a, b,c)) as lenPath,
			   FIRST(event_date of a) as start_date,
			   LAST(event_date of any(b,c)) as end_date)
	)
);
grant all on onboarding.inbound_revoked_npath to db_analytics;

DROP TABLE IF EXISTS onboarding.freq_inbound_revoked_npath;
CREATE TABLE onboarding.freq_inbound_revoked_npath
DISTRIBUTE BY HASH(path)
COMPRESS AS (
	select path, cast(avg( cast (end_date as date) - cast (start_date as date) ) as integer) duration, lenPath, count(*) cnt
	from onboarding.inbound_revoked_npath
	where lenPath >= 2
	group by 1, lenPath
);
grant all on onboarding.freq_inbound_revoked_npath to db_analytics;


select count(*) from onboarding.freq_inbound_revoked_npath where cnt>=5



-- Visualization Code for AppCenter
--INSERT INTO app_center_visualizations  (json) 
--SELECT json FROM Visualizer (
--    ON (select * from onboarding.freq_inbound_revoked_npath   ) PARTITION BY 1 
--AsterFunction('npath') 
--Title('53-inbound_info_revoked_npath') 
--VizType('sankey'));