DROP TABLE IF EXISTS onboarding.inbound_npath;
CREATE TABLE onboarding.inbound_npath
DISTRIBUTE BY HASH(cmusno) 
COMPRESS AS (
		SELECT * 
		FROM npath(
		ON (select cmusno, event_id, event_desc, domain_type, acq_chn, event_date,min(row_number) row_number from onboarding.event_list_18_0_to_90_removed
			where domain_type ='acq_chn' or(domain_type='CALL_CENTER' and event_desc like '%inbound%')
			group by 1,2,3,4,5,6)
		PARTITION BY cmusno
		ORDER BY row_number
		MODE('NONOVERLAPPING')
		SYMBOLS(domain_type in ('acq_chn') as a,
				domain_type in ('CALL_CENTER') as b)
		PATTERN('a.b+')  -- All application events
		RESULT(ACCUMULATE(event_desc of any(a, b)) as path,
			   FIRST(cmusno of a) as cmusno,
			   COUNT(cmusno of any(a, b)) as lenPath,
			   FIRST(event_date of a) as start_date,
			   LAST(event_date of b) as end_date)
	)
);
grant all on onboarding.inbound_npath to db_analytics;

DROP TABLE IF EXISTS onboarding.freq_inbound_npath;
CREATE TABLE onboarding.freq_inbound_npath
DISTRIBUTE BY HASH(path)
COMPRESS AS (
	select path, cast(avg( cast (end_date as date) - cast (start_date as date) ) as integer) duration, lenPath, count(*) cnt
	from onboarding.inbound_npath
	where lenPath >= 2
	group by 1, lenPath
);
grant all on onboarding.freq_inbound_npath to db_analytics;


select count(*) from onboarding.freq_inbound_npath where cnt>=5



-- Visualization Code for AppCenter
--INSERT INTO app_center_visualizations  (json) 
--SELECT json FROM Visualizer (
--    ON (select * from onboarding.freq_inbound_npath where cnt>=5 ) PARTITION BY 1 
--AsterFunction('npath') 
--Title('54-inbound_npath') 
--VizType('tree'));



----------------------------------------------

DROP TABLE IF EXISTS onboarding.inbound_npath;
CREATE TABLE onboarding.inbound_npath
DISTRIBUTE BY HASH(cmusno) 
COMPRESS AS (
		SELECT * 
		FROM npath(
		ON (select cmusno, event_id, event_desc, domain_type, acq_chn, event_date,min(row_number) row_number from onboarding.event_list_18_0_to_90_removed
			where domain_type ='acq_chn' or(domain_type='CALL_CENTER' and event_desc like '%inbound%')
			group by 1,2,3,4,5,6)
		PARTITION BY cmusno
		ORDER BY row_number
		MODE('NONOVERLAPPING')
		SYMBOLS(domain_type in ('acq_chn') as a,
				domain_type in ('CALL_CENTER') as b)
		PATTERN('a.b{1,4}')  -- All application events
		RESULT(ACCUMULATE(event_desc of any(a, b)) as path,
			   FIRST(cmusno of a) as cmusno,
			   COUNT(cmusno of any(a, b)) as lenPath,
			   FIRST(event_date of a) as start_date,
			   LAST(event_date of b) as end_date)
	)
);
grant all on onboarding.inbound_npath to db_analytics;

DROP TABLE IF EXISTS onboarding.freq_inbound_npath;
CREATE TABLE onboarding.freq_inbound_npath
DISTRIBUTE BY HASH(path)
COMPRESS AS (
	select path, cast(avg( cast (end_date as date) - cast (start_date as date) ) as integer) duration, lenPath, count(*) cnt
	from onboarding.inbound_npath
	where lenPath >= 2
	group by 1, lenPath
);
grant all on onboarding.freq_inbound_npath to db_analytics;


select count(*) from onboarding.freq_inbound_npath where cnt>=5



-- Visualization Code for AppCenter
--INSERT INTO app_center_visualizations  (json) 
--SELECT json FROM Visualizer (
--    ON (select * from onboarding.freq_inbound_npath ) PARTITION BY 1 
--AsterFunction('npath') 
--Title('54-inbound_npath') 
--VizType('sankey'));